//+------------------------------------------------------------------+
//|                                         My OZFx Squeeze v1.1.mq4 |
//|                                       Copyright  2008, Mas Awoo |
//|                                        original idea system OZFX |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#property copyright "Copyright  2008, Mas Awoo"
#property link      "mailto:mas_awoo@yahoo.com"
//--------------------------------------

extern int MAGICMA                      = 111111111;
extern double MinLots                   = 0.1;
extern double MaxLotSize                = 99;
extern double StopLoss                  = 50;
extern int    Slippage                  = 3; 
extern double TakeProfit1               = 50;
extern double TakeProfit2               = 100;
extern double TakeProfit3               = 1111;
extern string Agresif_Entry_System      = "___________________________________________________ ";
extern bool   AES                       = False;
extern double MaxTrades                 = 20;
extern string _______Chose_one_______   = "___________________________________________________";
extern bool   Active_TrailingStop       = False; //between Active_trailing & Just_BEP you must chose one.
extern double TrailingStop              = 50; 
extern bool   Use_4Step                 = False;
extern double STEP                      = 50;
extern bool   Just_BEP                  = True;
extern double BEP                       = 50;
extern string ____Money_Management____  = "If true, its calculate Lot for you";
extern bool   MM                        = True;
extern double MaximumRisk               = 0.02;
extern double IncreaseFactor            = 2;
extern string __Automatic_StopLoss__    = "If true, its calculate StopLoss for you";
extern bool   AutoSL                    = false;
extern bool   SL_use_2ATR               = false;
extern bool   SL_use_Moment_2MFI        = false;
extern string _____Moving_Average_____  = "MODE: 0=SMA, 1=EMA, 2=SMMA, 3=LWMA ";
extern double MA_PERIODE                = 200;
extern double MODE_MA                   = 0; //0=SMA, 1=EMA, 2=SMMA, 3=LWMA
extern string _______Stochastic_______  = "___________________________________________________";
extern double Stoch_Entry_Buy           = 80;
extern double Stoch_Entry_Sell          = 20;
extern double K_Period                  = 5;
extern double D_Period                  = 3;
extern double Slowing_Period            = 3;
extern string ___Money_Flow_Index_____  = "___________________________________________________";
extern double MFI_Period                = 7;
extern double MFI_Entry_Buy             = 50;
extern double MFI_Entry_Sell            = 50;
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber ()==MAGICMA )
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=MinLots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0, profit=0;                  // number of losses orders without a break
//---- select lot size
 lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(IncreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;lot=OrderLots(); 
        }
      if(losses>1) lot=lot*IncreaseFactor;
     }
//---- return lot size
   if(lot<MinLots) lot=MinLots;
   return(lot);
   if(lot>MaxLotSize ) lot=MaxLotSize;
   return(lot);
  }
  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double AC1, AC2, AO11, AO22, AO1, AO2,St,Sts, MA, Lots;
   int    res;
   double MFI,SL;
//---- go trading only for first tiks of new bar
   if (Volume[0]>1)return;
   if (CalculateCurrentOrders(Symbol())>=MaxTrades)return;
//---- get Moving Average 
   St=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_MAIN,0);
   Sts=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_SIGNAL,0);
   AC1=iCustom(NULL, 0, "AC1",1,0);
   AC2=iCustom(NULL, 0, "AC2",2,0);
   AO1=iCustom(NULL, 0, "AO1",0,0);
   AO2=iCustom(NULL, 0, "AO2",1,0);
   AO11=iCustom(NULL, 0, "AO1",0,1);
   AO22=iCustom(NULL, 0, "AO2",1,1);
   MA=iMA(NULL,0,MA_PERIODE,0,MODE_MA,0,0);
   MFI=iMFI(NULL,0,MFI_Period,0);
   
   if (MM==true)
   Lots=LotsOptimized();
   else 
   Lots =MinLots; 
   //---- Buy conditions
   if(MFI>MFI_Entry_Buy && AC1!=0 && AO1<0 && AO11<=0 && St>Stoch_Entry_Buy && St>Sts && Open[0]>MA )
   {
      {
     if (AutoSL==true )
      {if (SL_use_Moment_2MFI  ==true)
       SL=Ask-(iMomentum(NULL,0,MFI_Period,MODE_MA,0)+(iMFI(NULL,0,MFI_Period,0)*2))*Point;
      if (SL_use_2ATR==true)
       SL=Ask-(iATR(NULL,0,55,0)*2);
       }
     else 
      SL=Ask-StopLoss*Point;
      }
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,Ask+TakeProfit1*Point,"Mas Awoo",MAGICMA,0,Blue);
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,Ask+TakeProfit2*Point,"Mas Awoo",MAGICMA,0,Blue);
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,Ask+TakeProfit3*Point,"Mas Awoo",MAGICMA,0,Blue);
      return;
     }


  //----
//---- Sell conditions
   if(MFI<MFI_Entry_Sell && AC2!=0 && AO2>0 && AO22<=0 && St<Stoch_Entry_Sell && St<Sts && Open[0]<MA )
     {
      {
     if (AutoSL==true )
      {if (SL_use_Moment_2MFI  ==true)
       SL=Bid+(iMomentum(NULL,0,MFI_Period,MODE_MA,0)+(iMFI(NULL,0,MFI_Period,0)*5))*Point;
      if (SL_use_2ATR==true)
       SL=Bid+(iATR(NULL,0,55,0)*2);
       }
     else 
      SL=Bid+StopLoss*Point;
      }
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,Bid-TakeProfit1*Point,"Mas Awoo",MAGICMA,0,Red);
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,Bid-TakeProfit2*Point,"Mas Awoo",MAGICMA,0,Red);
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,Bid-TakeProfit3*Point,"Mas Awoo",MAGICMA,0,Red);
      return;
     }

  //----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double AC1, AC2, AO11, AO22, AO1, AO2, St, Sts, MA, MFI;
   int    res;
//---- go trading only for first tiks of new bar
   if (Volume[0]>1)return;
//---- get Moving Average 
   St=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_MAIN,0);
   Sts=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_SIGNAL,0);
   AC1=iCustom(NULL, 0, "AC1",1,0);
   AC2=iCustom(NULL, 0, "AC2",2,0);
   AO1=iCustom(NULL, 0, "AO1",0,0);
   AO2=iCustom(NULL, 0, "AO2",1,0);
   AO11=iCustom(NULL, 0, "AO1",0,1);
   AO22=iCustom(NULL, 0, "AO2",1,1);
   MA=iMA(NULL,0,MA_PERIODE,0,MODE_MA,0,0);
   MFI=iMFI(NULL,0,MFI_Period,0);
   

//---- get Moving Average 
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(MFI<MFI_Entry_Sell && AC2!=0 && AO2>0 && AO22<=0 && St<Stoch_Entry_Sell && St<Sts && Open[0]<MA)
          OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(MFI>MFI_Entry_Buy &&AC1!=0 && AO1<0 && AO11<=0 && St>Stoch_Entry_Buy && St>Sts && Open[0]>MA)
         OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }

  }
//+------------------------------------------------------------------+
//| Check For TrailingStop                                           |
//+------------------------------------------------------------------+
void TrailingStop ()
{
double total, cnt;
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderMagicNumber ()==MAGICMA 
         && OrderSymbol()==Symbol())   
        {
         if(OrderType()==OP_BUY)  
           {
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Blue);
                     return(0);
                    }
                 }
              }
           }
         else //
           {
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if(OrderStopLoss()==0.0 || 
                     OrderStopLoss()>(Ask+Point*TrailingStop))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
     return(0);
     }

//+------------------------------------------------------------------+
//| Check For BEP                                           |
//+------------------------------------------------------------------+
void UseBEP ()
{
double total, cnt;
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderMagicNumber ()==MAGICMA &&
         OrderSymbol()==Symbol())   
        {
         if(OrderType()==OP_BUY)  
           {
            if(BEP>0)  
              {                 
               if(Bid>=OrderOpenPrice()+Point*BEP && OrderStopLoss()<OrderOpenPrice())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
                     return(0);
                 }
              }
           }
         else //
           {
            if(BEP>0)  
              {                 
               if(Ask<=(OrderOpenPrice()-Point*BEP) && OrderStopLoss()>OrderOpenPrice())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
                     return(0);
                 }
              }
           }
        }
     }
     return(0);
     }

//+------------------------------------------------------------------+
//| Check For STEP                                           |
//+------------------------------------------------------------------+
void UseSTEP ()
{
double total, cnt;
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderMagicNumber ()==MAGICMA &&
         OrderSymbol()==Symbol())   
        {
         if(OrderType()==OP_BUY)  
           {
            if(STEP>0)  
              {                 
               if(Bid-OrderOpenPrice()>=Point*STEP && OrderOpenPrice()!=OrderStopLoss() &&  OrderOpenPrice()>OrderStopLoss() )
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
                     return(0);
                 }
               if(Bid-OrderStopLoss()>=Point*(STEP+STEP)&& OrderOpenPrice()<=OrderStopLoss())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*STEP,OrderTakeProfit(),0,Blue);
                     return(0);
                 }
              }
           }
         else //
           {
            if(STEP>0)  
              {                 
               if(OrderOpenPrice()-Ask>=Point*STEP && OrderOpenPrice()!=OrderStopLoss() && OrderOpenPrice()<OrderStopLoss())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                     return(0);
                 }
               if((OrderStopLoss()-Ask)>=(Point*(STEP+STEP)) && OrderOpenPrice()>=OrderStopLoss())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*STEP,OrderTakeProfit(),0,Red);
                     return(0);
                 }
              }
           }
        }
     }
     return(0);
     }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else 
   CheckForClose();
   if (Just_BEP==True)UseBEP();
   if (Active_TrailingStop==True) TrailingStop ();
   if (Use_4Step==True) UseSTEP ();
   if(AES==True && CalculateCurrentOrders(Symbol())>0 && CalculateCurrentOrders(Symbol())<MaxTrades) 
   CheckForOpen();

//----
  }
//+------------------------------------------------------------------+